/*  
  bgmatrix.h
  Inspired by :
  Matrix.h - Max7219 LED Matrix library for Arduino & Wiring
  Copyright (c) 2006 Nicholas Zambetti.  All right reserved.

  You can use it at commented in Nicholas Zambetti files.
  https://github.com/lstoll/arduino-libraries/tree/master/Matrix
  https://github.com/lstoll/arduino-libraries/blob/master/Matrix/Matrix.h  

  Many improvements could be done, but I didn't want to spend to much time 
  developping this module.
============================================================================*/

#ifndef bgMatrix_h
#define bgMatrix_h
#define uint8_t byte

#include <Arduino.h>

class Matrix {
//============  
  private:
    uint8_t _pinData;
    uint8_t _pinClock;
    uint8_t _pinLoad;
    
  public:

    uint8_t* _pabBuffer;
    uint8_t _screens;
    uint8_t _maximumX;
    word    _wBufSize;
    word    _wBufSize_8;

    Matrix(uint8_t, uint8_t, uint8_t, byte*, word = 1, uint8_t = 1); 

    void WriteRegister(byte, byte, byte = 0);
    
    void setRegister(uint8_t, uint8_t);

    void setScanLimit(uint8_t);

    void WriteDot(uint8_t, uint8_t, uint8_t);

    void setBrightness(uint8_t);
    void Clear(void);
    void Update(int = 0, byte = 0);
};

#endif

