#include "bgmatrix.h"
#include "bgmatrixtext.h"

/*
ex0287_LED_Matrix
Use matrix displays to write a text on them and to shift the writtern text.
==========================================================================*/

const byte pinClock = 3; // Pin assignation 
const byte pinLoad  = 2;
const byte pinData  = 4;
const byte bNbScreens = 8; // number of LED matrix connected
const int nNbChar = 40; // number of characters memorised in the buffer

byte abBuf[8*nNbChar]; // To define the symbols displayed on the LED matrix

int glnShift = 0;      // How much are the LED shifted
int glnShiftDelta = 1; // Right shift

String strText1 = "A TEXT STRING TO BE DISPLAYED     ";

Matrix myMatrix = Matrix(pinData, pinClock, pinLoad, abBuf, strText1.length(), bNbScreens); // create Matrix instance

void setup() {
//============
//Serial.begin(115200);  // For debugging.

// Change l'intensité des LED
myMatrix.setBrightness(1); // valeurs admises entre 0 et 15

// Define the text to be writter on the LED displays
for (int nX=0; nX<nNbChar; nX++) setChar(abBuf,nX*8, char(byte('A') + nX));  // Put the alphabet in the buffer

for (int nX=0; nX<strText1.length(); nX++) setChar(abBuf,nX*8, strText1[nX]);  // Put a text in the buffer

// Write a dot in the LED screen, juste as an example
myMatrix.WriteDot(0, 7, 1);  myMatrix.WriteDot(0, 4, 1); 

// Start by writing the text, shifted
glnShift = 5;
myMatrix.Update(glnShift, 0);
delay(1000);

// Clear a written dot, juste as an example
myMatrix.WriteDot(0, 4, 0); 

glnShift = 40;
glnShiftDelta = -1;
//myMatrix.Clear();  myMatrix.Update(0, 0);
} // setup

void loop() {
//===========
myMatrix.Update(glnShift, 0);

// Shift the text.
glnShift += glnShiftDelta;
if (glnShift <= -8*nNbChar-40) glnShiftDelta = 1;  // Right shift
if (glnShift >=38+18) glnShiftDelta = -1;  // Left shift

delay(50);
} // loop

